package cn.com.infosec.math.ec;

import java.math.BigInteger;

class WNafMultiplier implements ECMultiplier {
   public byte[] windowNaf(byte width, BigInteger k) {
      byte[] var7 = new byte[k.bitLength() + 1];
      short var3;
      BigInteger var4 = BigInteger.valueOf((long)(var3 = (short)(1 << width)));
      int var5 = 0;

      int var6;
      for(var6 = 0; k.signum() > 0; ++var5) {
         if (k.testBit(0)) {
            BigInteger var9;
            if ((var9 = k.mod(var4)).testBit(width - 1)) {
               var7[var5] = (byte)(var9.intValue() - var3);
            } else {
               var7[var5] = (byte)var9.intValue();
            }

            k = k.subtract(BigInteger.valueOf((long)var7[var5]));
            var6 = var5;
         } else {
            var7[var5] = 0;
         }

         k = k.shiftRight(1);
      }

      byte[] k1;
      byte[] var10000 = k1 = new byte[width = var6 + 1];
      System.arraycopy(var7, 0, k1, 0, width);
      return var10000;
   }

   public ECPoint multiply(ECPoint p, BigInteger k, PreCompInfo preCompInfo) {
      WNafPreCompInfo preCompInfo1;
      if (preCompInfo != null && preCompInfo instanceof WNafPreCompInfo) {
         preCompInfo1 = (WNafPreCompInfo)preCompInfo;
      } else {
         preCompInfo1 = new WNafPreCompInfo.<init>();
      }

      int var4;
      byte var5;
      byte var13;
      if ((var4 = k.bitLength()) < 13) {
         var13 = 2;
         var5 = 1;
      } else if (var4 < 41) {
         var13 = 3;
         var5 = 2;
      } else if (var4 < 121) {
         var13 = 4;
         var5 = 4;
      } else if (var4 < 337) {
         var13 = 5;
         var5 = 8;
      } else if (var4 < 897) {
         var13 = 6;
         var5 = 16;
      } else if (var4 < 2305) {
         var13 = 7;
         var5 = 32;
      } else {
         var13 = 8;
         var5 = 127;
      }

      int var6 = 1;
      ECPoint[] var7;
      ECPoint[] var10000 = var7 = preCompInfo1.getPreComp();
      ECPoint var8 = preCompInfo1.getTwiceP();
      if (var10000 == null) {
         (var7 = new ECPoint[1])[0] = p;
      } else {
         var6 = var7.length;
      }

      if (var8 == null) {
         var8 = p.twice();
      }

      ECPoint[] var9;
      if (var6 < var5) {
         var9 = new ECPoint[var5];
         System.arraycopy(var7, 0, var9, 0, var6);

         while(var6 < var5) {
            var9[var6] = var8.add(var9[var6 - 1]);
            ++var6;
         }
      } else {
         var9 = var7;
      }

      byte[] var10;
      int var14 = (var10 = this.windowNaf(var13, k)).length;
      ECPoint k1 = p.getCurve().getInfinity();

      for(var4 = var14 - 1; var4 >= 0; --var4) {
         k1 = k1.twice();
         if (var10[var4] != 0) {
            if (var10[var4] > 0) {
               k1 = k1.add(var9[(var10[var4] - 1) / 2]);
            } else {
               k1 = k1.subtract(var9[(-var10[var4] - 1) / 2]);
            }
         }
      }

      preCompInfo1.setPreComp(var9);
      preCompInfo1.setTwiceP(var8);
      p.setPreCompInfo(preCompInfo1);
      return k1;
   }
}
